C Will read X, Y, BZ from zgoubi.plt (filled up using IL=2 in DIPOLE); 
C will organize these data and store as a 2D field map (Z==0) in consty2FieldMap.out.
C This field map is usable with TOSCA[MOD=25].
C Could be extended to provide 3D mad, for use with TOSCA[MOD=24].

C Working hypotheses below have to be consistent with OBJET & DIPOLE data in CONSTY

      implicit double precision (a-h,o-z)

      character(220) txt220
      parameter (mxa = 600, mxr = 400, mxz = 100)
      dimension aa(mxa), rr(mxr), zz(mxz)
      dimension ba(mxa,mxr,mxz),br(mxa,mxr,mxz),bz(mxa,mxr,mxz)
      parameter (rad = (4.d0 * atan(1.d0)) /180.d0)


      open(unit=1,file='zgoubi.impdev.out')
      read(1,fmt='(a)',err=15,end=15) txt220
      open(unit=2,file='temp.out')
 1    continue
             read(1,fmt='(a)',err=15,end=15) txt220
c             write(*,*) txt220
             write(2,fmt='(a)') txt220
      goto 1
 15   continue
     
      close(1)
      close(2)
        
      call system('rm temp2.out')
      call system('sort -k 2 temp.out > temp2.out')
      call system('mv -f temp.out2 temp.out')
      open(unit=1,file='temp.out')
      open(unit=2,file='impdev2FieldMap.out')



C read 2-line header
          read(1,fmt='(a)')
          read(1,fmt='(a)')

C Working hypotheses ------------------------------------------
      AT = 360.d0  * rad    ! rad
      ia = 314+1            ! number of mesh nodes = numb. steps+1, longitudinal
      dtta = AT/dble(ia-1)  ! rad
C Filed map is 2D, z==0
      dz = 0d0 ;  dR = 0.5 ! cm.  dR is the Y-sampling in OBJET
C Filed map extends ~ 10 - 70 cm
      jr = 121 ; kz = 1    ! have to be odd.  jr is the number of particles in OBJET
C -------------------------------------------------------------

      write(*,*) 'Number of mesh nodes in X/Y/Z : ',ia,'/',jr,'/',kz
      write(*,*) 'type enter to continue'
      read(*,*)
      write(*,*) 'Ok, now busy, making map ... wait'
      write(*,*) 'Map will be in impdev2FieldMap.out'

      if(ia .gt. mxa) stop ' Too many angles'
      if(jr .gt. mxr) stop ' Too many radii'
      if(kz .gt. mxz) stop ' Too many Zs'

      do i = 1, ia            
        aa(i) = dble(i-1) * dtta
      enddo

      bami = 1d10
      bama = -1d10
      brmi = 1d10
      brma = -1d10
      bzmi = 1d10
      bzma = -1d10

      xav = -1d10
      do j = 1, jr
        jj = (jr+1)/2 + j/2*(-1)**j 
        do k = 1, kz
          kk = (kz+1)/2 + k/2*(-1)**k
          iiia = 0
          do i = 1, ia
 9           read(1,*,err=10,end=10) txt220
             read(txt220,*) D, Y, T, Z, P, X, S, BX, BY, BZZ
            if(x .eq. xav ) goto 9 ! happens to be 2 steps at start 
            xav = x
            if(i.eq.ia) read(1,*,err=10,end=10) ! because integr writes twice at the last integration step

            iiia = iiia + 1
            rr(jj) = Y
            zz(kk) = Z

            ba(i,jj,kk) = BX
            br(i,jj,kk) = BY
            bz(i,jj,kk) = BZZ

            if(bami .gt. bx) bami = bx
            if(bama .lt. bx) bama = bx
            if(brmi .gt. by) brmi = by
            if(brma .lt. by) brma = by
            if(bzmi .gt. bzz) bzmi = bzz
            if(bzma .lt. bzz) bzma = bzz

c             write(*,*) i,jj,kk,aa(i),rr(j),zz(k),
c     >         ba(i,jj,kk), br(i,jj,kk), bz(i,jj,kk)

          enddo

          write(*,*) ' Numb. of angle nodes: ',iiia,', jr=',jr

        enddo
      enddo

 10   continue

      write(*,*) ' Done reading ! '

      RM = rr(1 + jr/2)    ! cm
      xpas = dtta * RM   ! cm
      write(*,*) ' Arc mesh step at RM = ',RM,' is ',xpas,' cm'

      write(*,*) ' Min - max field components :  '
      write(*,*) '      ba :  ',bami,'/',bama
      write(*,*) '      br :  ',brmi,'/',brma
      write(*,*) '      bz :  ',bzmi,'/',bzma

      Rmin = rr(1)
      write(2,fmt='(f8.2,f8.2,f20.14,f8.2,a)') Rmin , DR, DTTA/rad, DZ,
     >'       ! R_min (cm), DR (cm), DTTA (deg), DZ (cm) '
      write(2,fmt='(a)') '# Field map generated using impdev2FieldMap'
      write(2,fmt='(a)') 
     >'# AT/deg   RM/cm   xpas/cm  dR/cm  dZ/cm  ia jr  kz : '
      write(2,fmt='(a,1p,5(e14.6,1x),3(i5,1x))') 
     >'#', AT/((4.d0 * atan(1.d0)) /180.d0), RM,xpas,dR,dZ,ia,jr,kz
      write(2,fmt='(a)') 
     >'#  theta/rad    R/cm    Z/cm      B_theta   B_R    B_Z'

      do j = 1, jr
        do k = 1, kz
          do i = 1, ia            
            write(2,fmt='(1p,e18.10,1x,
     >      0p,2(f11.5,1x), 
     >      1p,3(e18.10,1x),3(i5,1x))') 
     >      rr(j)*cos(aa(i)),zz(k),rr(j)*sin(aa(i)),
C     >      aa(i),rr(j),zz(k),
     >      ba(i,j,k), br(i,j,k), bz(i,j,k),i,j,k
          enddo
        enddo
      enddo

      close(1)
      close(2)

      stop
      end

