
set title "Plotted from file zgoubi.fai " font "sans, 16 \n ~ " 

set key maxcol 1
set key spac 3
set key t c  font "Roman, 18"

#set logscale y 

set xtics mirror font  "sans, 16"
set ytics nomirror font  "sans, 16"
set y2tics mirror font  "sans, 16"

# set size ratio 1.

set xlabel "E_k [MeV]" font  "sans, 18"
set ylabel "p [MeV/c]" font  "sans, 18"
set y2label "E [MeV/c]" font  "sans, 18"

cm2m = 0.01
MeV2eV = 1e6
am = 938.27203
c = 2.99792458e8

set xrange [0:]        # m
set yrange [0:]        # m

plot  \
   "zgoubi.fai" u ($24):(sqrt($25**2 -am*am)) axes x1y1 w p pt 4 lc rgb "red" tit "p(E_k)"  ,\
   "zgoubi.fai" u ($24):($25) axes x1y2 w p pt 5 lc rgb "blue" tit "E(E_k)" 

#     set terminal postscript eps blacktext color  enh size 8cm,8cm "Times-Sans" 16
     set terminal postscript eps blacktext color  enh  "Times-Sans" 16
     set output "gnuplot_zgoubi.fai_E.vs.Ek.eps"  
     replot  
     set terminal X11  
     unset output  

 
pause 1

set xtics mirror font  "sans, 16"
set ytics mirror font  "sans, 16"
unset y2tics

# set size ratio 1.

set xlabel "E_k [MeV]" font  "sans, 18"
set ylabel "v/c" font  "sans, 18"
unset y2label

plot  \
   "zgoubi.fai" u ($24):(sqrt($25**2 -am*am)/$25) axes x1y1 w p pt 4 lc rgb "red" tit "{/Symbol b}(E_k)"

#     set terminal postscript eps blacktext color  enh size 8cm,8cm "Times-Sans" 16
     set terminal postscript eps blacktext color  enh  "Times-Sans" 16
     set output "gnuplot_zgoubi.fai_bta.vs.Ek.eps"  
     replot  
     set terminal X11  
     unset output  

 
pause 1
exit

